vsg: vsg::DeviceFeatures Class Reference

vsg 1.1.9 VulkanSceneGraph library |

Loading...
Searching...
No Matches
Classes | Public Member Functions | Protected Types | Protected Attributes | List of all members
vsg::DeviceFeatures Class Reference

`#include <DeviceFeatures.h>`

Inheritance diagram for vsg::DeviceFeatures:
[legend]
Collaboration diagram for vsg::DeviceFeatures:
[legend]

## Classes
struct | FeatureHeader

## Public Member Functions
| DeviceFeatures (const DeviceFeatures &)=delete
DeviceFeatures & | operator= (const DeviceFeatures &)=delete
template<typename FeatureStruct, VkStructureType type>
FeatureStruct & | get ()
VkPhysicalDeviceFeatures & | get ()
void | clear ()
| clear all the feature structures
void * | data () const
Public Member Functions inherited from vsg::Inherit< Object, DeviceFeatures >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
void | accept (RecordTraversal &visitor) const override
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual void | traverse (Visitor &)
virtual void | traverse (ConstVisitor &) const
virtual void | traverse (RecordTraversal &) const
virtual void | read (Input &input)
virtual void | write (Output &output) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Protected Types
using | DeleteHandler = void (*)(FeatureHeader* ptr)

## Protected Attributes
std::map< VkStructureType, std::pair< FeatureHeader *, DeleteHandler > > | _features

## Additional Inherited Members
Static Public Member Functions inherited from vsg::Inherit< Object, DeviceFeatures >
static ref_ptr< DeviceFeatures > | create (Args &&... args)
static ref_ptr< DeviceFeatures > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Detailed Description

DeviceFeatures is a container class for setting up Vulkan feature structures to be passed in vsg::Device creation. Automatically deletes associated created feature structures on destruction.

## Member Function Documentation

## ◆ data()

void * vsg::DeviceFeatures::data | ( |  | ) | const

data() is used as the VkCreateDeviceInfo.pNext setting automatically chains the pNext pointers of the used feature structures return nullptr when no features structures have been used.

## ◆ get() [1/2]

template<typename FeatureStruct, VkStructureType type>

FeatureStruct & vsg::DeviceFeatures::get | ( |  | ) |
| inline

get a Vulkan extension feature structure. usage example : auto& meshFeatures = features->get<VkPhysicalDeviceMeshShaderFeaturesNV, VK_STRUCTURE_TYPE_PHYSICAL_DEVICE_MESH_SHADER_FEATURES_NV>(); meshFeatures.meshShader = 1; meshFeatures.taskShader = 1;

## ◆ get() [2/2]

VkPhysicalDeviceFeatures & vsg::DeviceFeatures::get | ( |  | ) |

get the standard VkPhysicalDeviceFeatures structure. usage example : deviceFeatures->get().samplerAnisotropy = VK_TRUE;

The documentation for this class was generated from the following file:

- include/vsg/vk/DeviceFeatures.h